3 # Copyright (c) 2005 Linus Torvalds
4 # Copyright (c) 2006 Junio C Hamano
6 USAGE='[-a | --interactive] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit> | --amend] [-u] [-e] [--author <author>] [--template <file>] [[-i | -o] <path>...]'
11 git rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
24 echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
29 THIS_INDEX="$GIT_DIR/index"
30 NEXT_INDEX="$GIT_DIR/next-index$$"
33 cp -p "$THIS_INDEX" "$NEXT_INDEX"
37 # If TMP_INDEX is defined, that means we are doing
38 # "--only" partial commit, and that index file is used
39 # to build the tree for the commit. Otherwise, if
40 # NEXT_INDEX exists, that is the index file used to
41 # make the commit. Otherwise we are using as-is commit
42 # so the regular index file is what we use to compare.
43 if test '' != "$TMP_INDEX"
45 GIT_INDEX_FILE="$TMP_INDEX"
47 elif test -f "$NEXT_INDEX"
49 GIT_INDEX_FILE="$NEXT_INDEX"
53 if test "$status_only" = "t" -o "$use_status_color" = "t"; then
58 git runstatus ${color} \
59 ${verbose:+--verbose} \
61 ${untracked_files:+--untracked}
65 test -z "$TMP_INDEX" || {
66 test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
71 ################################################################
72 # Command line argument parsing and sanity checking
92 templatefile="`git config commit.template`"
96 -F|--F|-f|--f|--fi|--fil|--file)
97 case "$#" in 1) usage ;; esac
100 log_given=t$log_given
106 log_given=t$log_given
107 logfile=`expr "z$1" : 'z-[Ff]\(.*\)'`
110 --F=*|--f=*|--fi=*|--fil=*|--file=*)
112 log_given=t$log_given
113 logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'`
120 --au=*|--aut=*|--auth=*|--autho=*|--author=*)
121 force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'`
124 --au|--aut|--auth|--autho|--author)
125 case "$#" in 1) usage ;; esac
130 -e|--e|--ed|--edi|--edit)
134 -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
138 --int|--inte|--inter|--intera|--interac|--interact|--interacti|\
139 --interactiv|--interactive)
143 -o|--o|--on|--onl|--only)
147 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
148 case "$#" in 1) usage ;; esac
150 log_given=m$log_given
151 if test "$log_message" = ''
155 log_message="$log_message
163 log_given=m$log_given
164 if test "$log_message" = ''
166 log_message=`expr "z$1" : 'z-m\(.*\)'`
168 log_message="$log_message
170 `expr "z$1" : 'z-m\(.*\)'`"
175 --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
176 log_given=m$log_given
177 if test "$log_message" = ''
179 log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'`
181 log_message="$log_message
183 `expr "z$1" : 'zq-[^=]*=\(.*\)'`"
188 -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\
193 --a|--am|--ame|--amen|--amend)
199 case "$#" in 1) usage ;; esac
201 log_given=t$log_given
206 --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
207 --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
208 --reedit-messag=*|--reedit-message=*)
209 log_given=t$log_given
210 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
214 --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
215 --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\
217 case "$#" in 1) usage ;; esac
219 log_given=t$log_given
225 case "$#" in 1) usage ;; esac
227 log_given=t$log_given
232 --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
233 --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
235 log_given=t$log_given
236 use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
240 --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
241 --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
242 case "$#" in 1) usage ;; esac
244 log_given=t$log_given
249 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
253 -t|--t|--te|--tem|--temp|--templ|--templa|--templat|--template)
254 case "$#" in 1) usage ;; esac
260 -q|--q|--qu|--qui|--quie|--quiet)
264 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
268 -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\
269 --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\
270 --untracked-file|--untracked-files)
286 case "$edit_flag" in t) no_edit= ;; esac
288 ################################################################
289 # Sanity check options
291 case "$amend,$initial_commit" in
293 die "You do not have anything to amend." ;;
295 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
296 die "You are in the middle of a merge -- cannot amend."
302 die "Only one of -c/-C/-F can be used." ;;
304 die "Option -m cannot be combined with -c/-C/-F." ;;
307 case "$#,$also,$only,$amend" in
309 die "Only one of --include/--only can be used." ;;
311 die "No paths with --include/--only does not make sense." ;;
313 only_include_assumed="# Clever... amending the last one with dirty index." ;;
317 only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
322 case "$all,$interactive,$also,$#" in
324 die "Cannot use -a, --interactive or -i at the same time." ;;
326 die "Paths with -a does not make sense." ;;
328 die "Paths with --interactive does not make sense." ;;
330 die "No paths with -i does not make sense." ;;
333 if test ! -z "$templatefile" -a -z "$log_given"
335 if test ! -f "$templatefile"
337 die "Commit template file does not exist."
341 ################################################################
342 # Prepare index to have a tree to be committed
346 if test ! -f "$THIS_INDEX"
348 die 'nothing to commit (use "git add file1 file2" to include for commit)'
353 GIT_INDEX_FILE="$NEXT_INDEX" &&
354 export GIT_INDEX_FILE &&
355 git diff-files --name-only -z |
356 git update-index --remove -z --stdin
361 git ls-files --error-unmatch -- "$@" >/dev/null || exit
363 git diff-files --name-only -z -- "$@" |
366 GIT_INDEX_FILE="$NEXT_INDEX" &&
367 export GIT_INDEX_FILE &&
368 git update-index --remove -z --stdin
372 if test "$interactive" = t; then
373 git add --interactive || exit
379 if test -f "$GIT_DIR/MERGE_HEAD"
381 refuse_partial "Cannot do a partial commit during a merge."
384 TMP_INDEX="$GIT_DIR/tmp-index$$"
386 test -z "$initial_commit" && W=--with-tree=HEAD
387 commit_only=`git ls-files --error-unmatch $W -- "$@"` || exit
389 # Build a temporary index and update the real index
391 if test -z "$initial_commit"
393 GIT_INDEX_FILE="$THIS_INDEX" \
394 git read-tree --index-output="$TMP_INDEX" -i -m HEAD
399 printf '%s\n' "$commit_only" |
400 GIT_INDEX_FILE="$TMP_INDEX" \
401 git update-index --add --remove --stdin &&
404 printf '%s\n' "$commit_only" |
406 GIT_INDEX_FILE="$NEXT_INDEX"
407 export GIT_INDEX_FILE
408 git update-index --add --remove --stdin
415 ################################################################
416 # If we do as-is commit, the index file will be THIS_INDEX,
417 # otherwise NEXT_INDEX after we make this commit. We leave
418 # the index as is if we abort.
420 if test -f "$NEXT_INDEX"
422 USE_INDEX="$NEXT_INDEX"
424 USE_INDEX="$THIS_INDEX"
427 case "$status_only" in
429 # This will silently fail in a read-only repository, which is
431 GIT_INDEX_FILE="$USE_INDEX" git update-index -q --unmerged --refresh
436 GIT_INDEX_FILE="$USE_INDEX" git update-index -q --refresh || exit
440 ################################################################
441 # Grab commit message, write out tree and make commit.
443 if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
447 GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
449 GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
453 if test "$log_message" != ''
455 printf '%s\n' "$log_message"
456 elif test "$logfile" != ""
458 if test "$logfile" = -
461 echo >&2 "(reading log message from standard input)"
466 elif test "$use_commit" != ""
468 encoding=$(git config i18n.commitencoding || echo UTF-8)
469 git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
470 sed -e '1,/^$/d' -e 's/^ //'
471 elif test -f "$GIT_DIR/MERGE_MSG"
473 cat "$GIT_DIR/MERGE_MSG"
474 elif test -f "$GIT_DIR/SQUASH_MSG"
476 cat "$GIT_DIR/SQUASH_MSG"
477 elif test "$templatefile" != ""
480 fi | git stripspace >"$GIT_DIR"/COMMIT_EDITMSG
484 sign=$(git-var GIT_COMMITTER_IDENT | sed -e '
488 blank_before_signoff=
489 tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG |
490 grep 'Signed-off-by:' >/dev/null || blank_before_signoff='
492 tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG |
493 grep "$sign"$ >/dev/null ||
494 printf '%s%s\n' "$blank_before_signoff" "$sign" \
495 >>"$GIT_DIR"/COMMIT_EDITMSG
499 if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
501 echo "# It looks like you may be committing a MERGE."
502 echo "# If this is not correct, please remove the file"
503 printf '%s\n' "# $GIT_DIR/MERGE_HEAD"
504 echo "# and try again"
506 fi >>"$GIT_DIR"/COMMIT_EDITMSG
509 if test '' != "$use_commit"
511 eval "$(get_author_ident_from_commit "$use_commit")"
512 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
514 if test '' != "$force_author"
516 GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
517 GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
518 test '' != "$GIT_AUTHOR_NAME" &&
519 test '' != "$GIT_AUTHOR_EMAIL" ||
520 die "malformed --author parameter"
521 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
525 if test -z "$initial_commit"
528 if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
529 rloga='commit (merge)'
530 PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
531 elif test -n "$amend"; then
532 rloga='commit (amend)'
533 PARENTS=$(git cat-file commit HEAD |
534 sed -n -e '/^$/q' -e 's/^parent /-p /p')
536 current="$(git rev-parse --verify HEAD)"
538 if [ -z "$(git ls-files)" ]; then
539 echo >&2 'nothing to commit (use "git add file1 file2" to include for commit)'
543 rloga='commit (initial)'
546 set_reflog_action "$rloga"
548 if test -z "$no_edit"
552 echo "# Please enter the commit message for your changes."
553 echo "# (Comment lines starting with '#' will not be included)"
554 test -z "$only_include_assumed" || echo "$only_include_assumed"
556 } >>"$GIT_DIR"/COMMIT_EDITMSG
558 # we need to check if there is anything to commit
559 run_status >/dev/null
561 if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" ]
563 rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
571 git-var GIT_AUTHOR_IDENT > /dev/null || die
572 git-var GIT_COMMITTER_IDENT > /dev/null || die
573 git_editor "$GIT_DIR/COMMIT_EDITMSG"
579 if test -x "$GIT_DIR"/hooks/commit-msg
581 "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
585 if test -z "$no_edit"
593 ' "$GIT_DIR"/COMMIT_EDITMSG
595 cat "$GIT_DIR"/COMMIT_EDITMSG
597 git stripspace >"$GIT_DIR"/COMMIT_MSG
599 # Test whether the commit message has any content we didn't supply.
601 grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
602 git stripspace > "$GIT_DIR"/COMMIT_BAREMSG
604 # Is the commit message totally empty?
605 if test -s "$GIT_DIR"/COMMIT_BAREMSG
607 if test "$templatefile" != ""
609 # Test whether this is just the unaltered template.
610 if cnt=`sed -e '/^#/d' < "$templatefile" |
612 diff "$GIT_DIR"/COMMIT_BAREMSG - |
619 # No template, so the content in the commit message must
620 # have come from the user.
625 rm -f "$GIT_DIR"/COMMIT_BAREMSG
627 if test "$have_commitmsg" = "t"
629 if test -z "$TMP_INDEX"
631 tree=$(GIT_INDEX_FILE="$USE_INDEX" git write-tree)
633 tree=$(GIT_INDEX_FILE="$TMP_INDEX" git write-tree) &&
636 commit=$(git commit-tree $tree $PARENTS <"$GIT_DIR/COMMIT_MSG") &&
637 rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
638 git update-ref -m "$GIT_REFLOG_ACTION: $rlogm" HEAD $commit "$current" &&
639 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" &&
640 if test -f "$NEXT_INDEX"
642 mv "$NEXT_INDEX" "$THIS_INDEX"
647 echo >&2 "* no commit message? aborting commit."
651 rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
659 if test -x "$GIT_DIR"/hooks/post-commit
661 "$GIT_DIR"/hooks/post-commit
665 commit=`git diff-tree --always --shortstat --pretty="format:%h: %s"\
666 --summary --root HEAD --`
667 echo "Created${initial_commit:+ initial} commit $commit"